;**************************************************************************
;*
;* Title:		Test
;* Version:		1.0
;* Last updated:	00.09.12
;* Target:		AT90S2313
;*
;* Support E-mail:	rlievin@mail.com
;*
;* Code Size		:72 words
;* Low Register Usage	:2
;* High Register Usage	:5
;* Interrupt Usage	:nothing
;*
;* DESCRIPTION
;*
;* This application note tests the TI module.
;*
;**************************************************************************

.include "2313def.inc"

;***** WatchDog settings

;.equ	WDP=4	;0.24s at 5.0V (0.75s at 3.0V)
.equ	WDP=5	;0.49s at 5.0V (1.5s at 3.0V)
;.equ	WDP=6	;0.97s at 5.0V

;***** BAUD-rate settings at 10 Mhz for the UBRR register

				;BAUD-RATES @10MHz XTAL
.equ	N=64			; 9600
;.equ	N=42			;14400 
;.equ	N=32			;19200
;.equ	N=21			;28800
;.equ	N=15			;38400
;.equ	N=10			;57600



;**************************************************************************
;*
;*	VECTOR TABLE - EXECUTION STARTS HERE
;*
;**************************************************************************
	.cseg

	.org 	$0000
	rjmp	RESET			;Reset handler

	.org 	INT0addr
	rjmp	EXT_INT0		;External interrupt 0 handler

	.org 	INT1addr
	rjmp	EXT_INT1		;External interrupt 0 handler

	.org 	ICP1addr
	rjmp	TIM_CAPT1		;Timer/counter1 capture event handler

	.org	OC1addr
	rjmp	TIM_COMP1		;Timer/counter1 compare match handler

	.org	OVF1addr
	rjmp	TIM_OVF1		;Timer/counter1 overflow handler

	.org	OVF0addr
	rjmp	TIM_OVF0		;Timer/counter0 coverflow handler

	.org	URXCaddr
	rjmp	UART_RXC		;UART, RX complete handler

	.org	UDREaddr
	rjmp	UART_DRE		;UART, Data register empty handler

	.org	UTXCaddr
	rjmp	UART_TXC		;UART, TX complete handler

	.org ACIaddr
	rjmp	ANA_COMP		;Analog comparator handler

; unused vectors: return of interrupt

EXT_INT0:
EXT_INT1:
TIM_CAPT1:
TIM_COMP1:
TIM_OVF1:
TIM_OVF0:
UART_RXC:
UART_DRE:
UART_TXC:
ANA_COMP:
	reti

;***** Include subroutines

;.include "avr_buf.asm"	:to use RS232 subroutines (buffer)
.include "ti_prot.asm"	;to use TI subroutines


;***** Initialization (common part) 

        .def   	init	=r16
	.def	data	=r17

RESET:  
	ldi	init,low(RAMEND)	;init Stack Pointer	
	out	SPL,init
	ldi	init,0b00000010	 	;set port D bit 1 to output
	out	DDRD,init
	clr	init
	out     PORTB,init		;all outputs pins at 0
        out     DDRB,init		;all pins in input (Hi-Z)
	ldi	init,N			;init the baud rate generator
	out	UBRR,init
	sbi	UCR,TXEN		;transmitter enable
	sbi	UCR,RXEN		;receiver enable
	
;wait:	rcall	check			;wait that red=1 & white=1 (watchdog reset)
;	brtc	wait			;
;	sei				;enable interrupts
;	ldi	scratch,(1<<WDE) + WDP	;load the watchdog prescaler 
;	out	WDTCR,scratch		;and enable watchdog


;**************************************************************************
;*
;*      Test program for TI routines
;*
;**************************************************************************
ti_sub:	
	ldi	ti_reg,0x09
	rcall	ti_put
	ldi	ti_reg,0x68
	rcall	ti_put
	ldi	ti_reg,0x00
	rcall	ti_put
	ldi	ti_reg,0x00
	rcall	ti_put
	rcall	ti_get
	rcall	ti_get
	rcall	ti_get
	rcall	ti_get
jmp:	rjmp	jmp

.exit