/*  avr_prommer - prommer for AVR micro-controllers
 *  Copyright (C) 1999, 2000  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef AVR_FNCT_H
#define AVR_FNCT_H

#include "typedefs.h"

/* For AT90S1200 and 2313 */
#define S1200_MAX_CNT 512
#define S1200_MAX_EEP 128
#define S2313_MAX_CNT 1024
#define S2313_MAX_EEP 64
#define MAX_CNT 1024
#define MAX_EEP 64

extern int max_cnt;
extern int max_eep;

extern int avr_type;
extern char flash_fname[MAXCHARS];
extern char eeprom_fname[MAXCHARS];
extern char auto_flash[MAXCHARS];
extern int adr_cnt_flash, adr_cnt_eeprom;
extern word addrs[MAX_CNT];
extern word datas[MAX_CNT];
extern byte eep[MAX_EEP];

int get_flash_file(char *fname);
int get_eep_file(char *fname);
void avr_enable(void);
void avr_erase(void);
byte avr_read_dev_code(int loc);
void avr_pgm_code(int loc, word w);
word avr_read_code(int loc);
word avr_read_code(int loc);
byte avr_read_data(int loc);
void avr_pgm_data(int loc, int b);
void avr_pgm_flash(void);
void avr_pgm_eep(void);
int exit_key(void);
void avr_show_flash(void);
void avr_show_eep(void);
void avr_verify_flash(void);
void show_device_code(void);

#endif
