/*  ti_link - link program for TI calculators
 *  Copyright (C) 1999, 2000  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef LOWLEVEL_H
#define LOWLEVEL_H

#include "typedefs.h"

#define COM1ADR 0x3F8
#define COM2ADR 0x2F8
#define COM3ADR 0x3E8
#define COM4ADR 0x2E8

#define TXBUF 0
#define RXBUF 0
#define DIVLSB 0
#define DIVMSB 0
#define LCR 3
#define MCR 4
#define LSR 5
#define MSR 6
#define IER 1

#define BITRATE 19200
#define FALSE 0
#define TRUE 1 // or !0 ?

extern int com_adr;
extern byte mcr_shadow;
extern long t100us, t500us, t100ms, t10ms;

void sndbyt(byte b);
byte getbyt(void);
void setcom(int speed);
void wtk(long k);
void out_clk(int b);
void out_dat(int b);

void setup(void);
void issue_reset(void);
int get_dat(void);
void send_byte(byte b);
byte get_byte(void);

#endif
