/*  avr_prommer - prommer for AVR micro-controllers
 *  Copyright (C) 1999, 2000  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef IOPORTS_H
#define IOPORTS_H

#if defined(__BORLANDC__) // DOS
#include <dos.h>

#pragma argsused // to be quiet !
int ioperm(unsigned long from, unsigned long num, int turn_on)
{
  return 0;
}

#elif defined(WIN32) // Windows9x

#include <conio.h>

__inline int ioperm(unsigned long from, unsigned long num, int turn_on)
{
  return 0;
}

//#define inportb(port)        _inp(port)
//#define outportb(data, port) _outp(data, port)

__inline int inportb( unsigned short port )
{
 return _inp(port);
}

__inline void outportb ( unsigned char data, unsigned short port )
{
  _outp(port, data);
}


#else // Linux

#include <sys/perm.h>
#include <asm/io.h>

__inline unsigned char inportb (unsigned port)
{
	return inb(port);
}

__inline void outportb (unsigned port, unsigned char value)
{
	outb(value, port);
}
#endif

#endif
